<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN"
    "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml" xmlns:f="jakarta.faces.core"
	xmlns:h="jakarta.faces.html" xmlns:ui="jakarta.faces.facelets"
	xmlns:p="http://primefaces.org/ui"
	xmlns:of="http://omnifaces.org/functions">

<head>
<title></title>
</head>
<body>
	<f:view>
		<f:metadata>
			<f:viewParam name="id" value="#{showUserBean.id}" />
			<f:event type="jakarta.faces.event.PreRenderViewEvent"
				listener="#{showUserBean.preRenderView}" />
		</f:metadata>

		<ui:composition template="/template/default-admin.xhtml">
			<ui:param name="title" value="#{messages.title}" />

			<ui:define name="content">
				<h:form id="form">

					<h2>
						<h:outputText
							value="#{messages.user}: #{showUserBean.user.eppn}" />
					</h2>

					<p:messages id="messageBox" showDetail="true" />

					<div id="panel">
						<p:tabView id="tabVw" dynamic="true" cache="true">

							<p:tab id="tab1" title="#{messages.user_properties}">
								<p:panelGrid id="baseData" columns="2" layout="flex"
									columnClasses="col-12 md:col-3 xl:col-3, col-12 md:col-9 xl:col-9">

									<h:outputText value="#{messages.id}:" />
									<h:outputText value="#{showUserBean.user.id}" />

									<h:outputText value="#{messages.given_name}:" />
									<h:outputText value="#{showUserBean.user.givenName}" />

									<h:outputText value="#{messages.sur_name}:" />
									<h:outputText value="#{showUserBean.user.surName}" />

									<h:outputText value="#{messages.eppn}:" />
									<h:outputText value="#{showUserBean.user.eppn}" />

									<h:outputText value="#{messages.email_address}:" />
									<h:outputText value="#{showUserBean.user.email}" />

									<h:outputText value="#{messages.email_address_more}:" />
									<h:panelGroup>
										<ul>
											<ui:repeat var="emailAddress"
												value="#{showUserBean.user.emailAddresses.toArray()}">
												<li><h:outputText value="#{emailAddress}" /></li>
											</ui:repeat>
										</ul>
									</h:panelGroup>

									<h:outputText value="#{messages.uid_number}:" />
									<h:outputText value="#{showUserBean.user.uidNumber}" />

									<h:outputText value="#{messages.primary_group}:" />
									<h:panelGroup>
										<h:outputText
											value="#{showUserBean.user.primaryGroup.name} (" />
										<h:outputText
											value="Prefix: #{showUserBean.user.primaryGroup.prefix}"
											rendered="#{showUserBean.user.primaryGroup.class.simpleName == 'HomeOrgGroupEntity'}" />
										<h:outputText
											value=", GID: #{showUserBean.user.primaryGroup.gidNumber})" />
									</h:panelGroup>

									<h:outputText value="#{messages.persistent_id}:" />
									<h:panelGroup>
										<h:outputText
											value="#{showUserBean.user.persistentId} (#{showUserBean.user.persistentSpId}, #{showUserBean.user.idp.entityId})"
											rendered="#{showUserBean.user.class.simpleName == 'SamlUserEntity'}" />
										<h:outputText
											value="#{showUserBean.user.externalId} (externalId)"
											rendered="#{showUserBean.user.class.simpleName == 'ExternalUserEntity'}" />
									</h:panelGroup>

									<h:outputText value="#{messages.status}:" />
									<h:outputText value="#{showUserBean.user.userStatus}" />

									<h:outputText value="#{messages.last_status_change}:" />
									<h:outputText
										value="#{of:formatDate(showUserBean.user.lastStatusChange, 'dd.MM.yyyy HH:mm')}" />

									<h:outputText value="#{messages.last_update}:" />
									<h:outputText
										value="#{of:formatDate(showUserBean.user.lastUpdate, 'dd.MM.yyyy HH:mm')}" />

									<h:outputText value="#{messages.last_failed_update}:" />
									<h:outputText
										value="#{of:formatDate(showUserBean.user.lastFailedUpdate, 'dd.MM.yyyy HH:mm')}" />

									<h:outputText value="#{messages.next_scheduled_update}:" />
									<h:outputText
										value="#{of:formatDate(showUserBean.user.scheduledUpdate, 'dd.MM.yyyy HH:mm')}" />

								</p:panelGrid>
							</p:tab>


							<p:tab id="tab2" title="#{messages.roles}">
								<p:pickList var="role" value="#{showUserBean.roleList}"
									itemLabel="#{role.name}" itemValue="#{role}"
									converter="#{roleConverter}" showSourceFilter="true"
									showTargetFilter="true" filterMatchMode="contains">
									<p:ajax event="transfer" listener="#{showUserBean.onTransfer}" />
								</p:pickList>
							</p:tab>


							<p:tab id="tab3" title="#{messages.saml_values}">
								<p:dataTable id="attrData" style="min-width: 500px;"
									value="#{showUserBean.user.attributeStore.keySet().toArray()}"
									var="key">
									<p:column>
										<f:facet name="header">
											<h:outputText value="#{messages.name}" />
										</f:facet>
										<h:outputText value="#{key}" style="font-size: 80%;" />
									</p:column>
									<p:column>
										<f:facet name="header">
											<h:outputText value="#{messages.value}" />
										</f:facet>
										<h:outputText
											value="#{showUserBean.user.attributeStore.get(key)}" />
									</p:column>
								</p:dataTable>
								<p:panel style="margin-top: 12px;"
									rendered="#{showUserBean.user.class.simpleName eq 'SamlUserEntity'}">
									<p:commandButton value="#{messages.attr_query}"
										action="#{showUserBean.updateFromIdp()}" update="@form" />
									<p:ajaxStatus id="ajaxStatusPanelSaml"
										style="display: inline-block; margin-left: 8px; vertical-align: baseline;">
										<f:facet name="start">
											<h:graphicImage value="#{resource['/img/ajax-loader.gif']}"
												alt="#{messages.loading}" />
										</f:facet>
										<f:facet name="complete">
											<h:outputText value="" />
										</f:facet>
									</p:ajaxStatus>
								</p:panel>
								<p:panel style="margin-top: 12px;"
									rendered="#{showUserBean.user.class.simpleName eq 'OidcUserEntity'}">
									<p:commandButton value="#{messages.attr_query}"
										action="#{showUserBean.updateFromOp()}" update="@form" />
									<p:ajaxStatus id="ajaxStatusPanelOidc"
										style="display: inline-block; margin-left: 8px; vertical-align: baseline;">
										<f:facet name="start">
											<h:graphicImage value="#{resource['/img/ajax-loader.gif']}"
												alt="#{messages.loading}" />
										</f:facet>
										<f:facet name="complete">
											<h:outputText value="" />
										</f:facet>
									</p:ajaxStatus>
								</p:panel>
							</p:tab>

							<p:tab id="tab4" title="#{messages.registered_services}">
								<p:dataTable id="registeredTable" var="registry"
									value="#{showUserBean.registryList}">
									<p:column>
										<f:facet name="header">
											<h:outputText value="#{messages.id}" />
										</f:facet>
										<h:outputText value="#{registry.id}" />
									</p:column>
									<p:column>
										<f:facet name="header">
											<h:outputText value="#{messages.service}" />
										</f:facet>
										<h:link outcome="show-registry.xhtml"
											value="#{registry.service.name}">
											<f:param name="id" value="#{registry.id}" />
										</h:link>
									</p:column>
									<p:column>
										<f:facet name="header">
											<h:outputText value="#{messages.registered_time}" />
										</f:facet>
										<h:outputText
											value="#{of:formatDate(registry.agreedTime, 'dd.MM.yyyy HH:mm')}" />
									</p:column>
									<p:column>
										<f:facet name="header">
											<h:outputText value="#{messages.status}" />
										</f:facet>
										<h:outputText value="#{registry.registryStatus}" />
									</p:column>
								</p:dataTable>
								<div style="margin-top: 12px;">
									<p:commandButton value="#{messages.check_registries}"
										action="#{showUserBean.checkAllRegistries()}" update="@form" />
									<p:ajaxStatus id="ajaxCARStatusPanel"
										style="display: inline-block; margin-left: 8px; vertical-align: baseline;">
										<f:facet name="start">
											<h:graphicImage value="#{resource['/img/ajax-loader.gif']}"
												alt="#{messages.loading}" />
										</f:facet>
										<f:facet name="complete">
											<h:outputText value="" />
										</f:facet>
									</p:ajaxStatus>
								</div>								
								
							</p:tab>

							<p:tab id="tab5" title="#{messages.more_properties}">
								<p:dataTable id="storeData" style="min-width: 500px;"
									value="#{showUserBean.user.genericStore.keySet().toArray()}"
									var="key">
									<p:column>
										<f:facet name="header">
											<h:outputText value="#{messages.name}" />
										</f:facet>
										<h:outputText value="#{key}" style="font-size: 80%;" />
									</p:column>
									<p:column>
										<f:facet name="header">
											<h:outputText value="#{messages.value}" />
										</f:facet>
										<h:outputText
											value="#{showUserBean.user.genericStore.get(key)}" />
									</p:column>
								</p:dataTable>
							</p:tab>

							<p:tab id="tab6" title="#{messages.secondary_groups}">
								<p:dataTable id="secGroupData" style="min-width: 500px;"
									value="#{showUserBean.groupList}" var="group">
									<p:column>
										<f:facet name="header">
											<h:outputText value="#{messages.name}" />
										</f:facet>
										<h:outputText
											value="#{group.class.simpleName}: #{group.name} " />
										<h:outputText value="(#{group.prefix})"
											rendered="#{group.class.simpleName == 'HomeOrgGroupEntity'}" />
									</p:column>
									<p:column>
										<f:facet name="header">
											<h:outputText value="#{messages.id}" />
										</f:facet>
										<h:outputText value="#{group.gidNumber}" />
									</p:column>
								</p:dataTable>
							</p:tab>

							<p:tab id="tab7" title="#{messages.attribute_sources}">
								<p:dataTable id="asData" style="min-width: 500px;"
									value="#{showUserBean.asUserAttrList}" var="ua">
									<p:column sortBy="#{ua.attributeSource.name}">
										<f:facet name="header">
											<h:outputText value="#{messages.name}" />
										</f:facet>
										<h:outputText value="#{ua.attributeSource.name}" />
									</p:column>
									<p:column sortBy="#{ua.lastSuccessfulQuery}">
										<f:facet name="header">
											<h:outputText value="#{messages.last_update}" />
										</f:facet>
										<h:outputText
											value="#{of:formatDate(ua.lastQuery, 'dd.MM.yyyy HH:mm')}" />
									</p:column>
									<p:column sortBy="#{ua.lastSuccessfulQuery}">
										<f:facet name="header">
											<h:outputText value="#{messages.last_successful_update}" />
										</f:facet>
										<h:outputText
											value="#{of:formatDate(ua.lastSuccessfulQuery, 'dd.MM.yyyy HH:mm')}" />
									</p:column>
									<p:column>
										<f:facet name="header">
											<h:outputText value="#{messages.message}" />
										</f:facet>
										<h:outputText value="#{ua.queryMessage}" />
									</p:column>
									<p:column>
										<f:facet name="header">
											<h:outputText value="#{messages.status}" />
										</f:facet>
										<h:outputText value="#{ua.queryStatus}" />
									</p:column>
									<p:column style="width:32px">
										<p:commandLink update=":form:documentPanel"
											oncomplete="PF('documentDialog').show()" title="View Detail">
											<f:setPropertyActionListener value="#{ua}"
												target="#{showUserBean.selectedUserAttr}" />
											<i class="pi pi-search"></i>
										</p:commandLink>
									</p:column>
								</p:dataTable>
							</p:tab>

							<p:tab id="tab8" title="#{messages.audit}">
								<p:dataTable id="auditData" style="min-width: 500px;"
									value="#{showUserBean.auditUserEntryList}" var="audit"
									paginator="true" lazy="true" rows="15">
									<p:column sortBy="#{audit.id}">
										<f:facet name="header">
											<h:outputText value="#{messages.id}" />
										</f:facet>										
										<h:link outcome="/admin/audit/show-audit-entry.xhtml" value="#{audit.id}">
      										<f:param name="id" value="#{audit.id}"/>
    									</h:link>
									</p:column>

									<p:column sortBy="#{audit.endTime}">
										<f:facet name="header">
											<h:outputText value="#{messages.date}" />
										</f:facet>
										<h:link outcome="/admin/audit/show-audit-entry.xhtml"
											value="#{audit.endTime}">
											<f:param name="id" value="#{audit.id}" />
										</h:link>
									</p:column>

									<p:column sortBy="#{audit.detail}" filterBy="#{audit.detail}"
										filterMatchMode="contains">
										<f:facet name="header">
											<h:outputText value="#{messages.audit_detail}" />
										</f:facet>
										<h:outputText value="#{audit.detail}" />
									</p:column>

									<p:column sortBy="#{audit.name}" filterBy="#{audit.name}">
										<f:facet name="header">
											<h:outputText value="#{messages.name}" />
										</f:facet>
										<h:outputText value="#{audit.name}" />
									</p:column>

									<p:column sortBy="#{audit.executor}"
										filterBy="#{audit.executor}" filterMatchMode="contains">
										<f:facet name="header">
											<h:outputText value="#{messages.executor}" />
										</f:facet>
										<h:outputText value="#{audit.executor}" />
									</p:column>
									<p:column>
										<f:facet name="header">
											<h:outputText value="#{messages.time_taken}" />
										</f:facet>
										<h:outputText
											value="#{audit.endTime.time - audit.startTime.time} ms" />
									</p:column>

								</p:dataTable>
							</p:tab>

						</p:tabView>
					</div>


					<p:dialog id="dialog" header="Detail" showEffect="fade"
						widgetVar="documentDialog" modal="true" resizable="true"
						width="600px">
						<p:outputPanel id="documentPanel">
							<p:panelGrid columns="2" layout="flex"
								columnClasses="col-12 md:col-3 xl:col-3, col-12 md:col-9 xl:col-9"
								rendered="#{not empty showUserBean.selectedUserAttr}">

								<h:outputLabel for="name2" value="#{messages.name}" />
								<h:outputText id="name2"
									value="#{showUserBean.selectedUserAttr.attributeSource.name}" />

								<h:outputLabel value="#{messages.attribute_sources_for}" />
								<p:dataList var="ass"
									value="#{showUserBean.selectedAttributeSource.attributeSourceServices.toArray()}">
									<h:outputText value="#{ass.service.name}" />
								</p:dataList>

							</p:panelGrid>
							<p:dataTable var="v"
								value="#{showUserBean.selectedUserAttr.values.toArray()}">
								<p:column style="width:128px">
									<f:facet name="header">
										<h:outputText value="#{messages.key}" />
									</f:facet>
									<h:outputText value="#{v.key}" />
								</p:column>
								<p:column style="width:256px">
									<f:facet name="header">
										<h:outputText value="#{messages.value}" />
									</f:facet>
									<h:outputText value="#{v.valueString}" />
								</p:column>
							</p:dataTable>
						</p:outputPanel>
					</p:dialog>


				</h:form>

			</ui:define>
		</ui:composition>
	</f:view>
</body>
</html>
